#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK72x72x72NN0x0x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=72, NB=72, KB=72, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=3, ku=72, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + 72;
   const double *stN = B + (((ldb) << 6)+((ldb) << 3));
   const double *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 4 - (((lda) << 6)+((lda) << 3)), incAn = -72;
   #define incBk 72
   const int incBm = -72, incBn = (((ldb) << 1)+ldb);
   #define incCm 4
   const int incCn = (((ldc) << 1)+ldc) - 72;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      ATL_pfl1R(pfA+64);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rC0_0 = rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 = rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 = rA2 * rB0;
         rB1 = *pB1;
         rC3_0 = rA3 * rB0;
         rB2 = *pB2;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC3_1 = rA3 * rB1;
         rC0_2 = rA0 * rB2;
         rC1_2 = rA1 * rB2;
         rC2_2 = rA2 * rB2;
         rC3_2 = rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[1];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[1];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[1];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[2];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[2];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[3];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[3];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[3];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[4];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[4];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[5];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[5];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[5];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[6];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[6];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[7];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[7];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[7];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[8];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[8];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[9];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[9];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[9];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[10];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[10];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[11];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[11];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[11];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[12];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[12];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[13];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[13];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[13];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[14];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[14];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[15];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[15];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[15];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[16];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[16];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[17];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[17];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[17];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[18];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[18];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[19];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[19];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[19];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[20];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[20];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[21];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[21];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[21];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[22];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[22];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[23];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[23];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[23];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[24];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[24];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[24];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[25];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[25];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[25];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[26];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[26];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[26];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[27];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[27];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[27];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[28];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[28];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[28];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[29];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[29];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[29];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[30];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[30];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[30];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[31];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[31];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[31];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[32];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[32];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[32];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[33];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[33];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[33];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[34];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[34];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[34];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[35];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[35];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[35];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[36];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[36];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[36];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[37];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[37];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[37];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[38];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[38];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[38];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[39];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[39];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[39];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[40];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[40];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[40];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[41];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[41];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[41];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[42];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[42];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[42];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[43];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[43];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[43];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[44];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[44];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[44];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[45];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[45];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[45];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[46];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[46];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[46];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[47];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[47];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[47];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[48];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[48];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[48];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[49];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[49];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[49];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[50];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[50];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[50];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[51];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[51];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[51];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[52];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[52];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[52];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[53];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[53];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[53];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[54];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[54];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[54];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[55];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[55];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[55];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[56];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[56];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[56];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[57];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[57];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[57];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[58];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[58];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[58];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[59];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[59];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[59];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[60];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[60];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[60];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[61];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[61];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[61];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[62];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[62];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[62];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[63];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[63];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[63];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[64];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[64];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[64];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[65];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[65];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[65];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[66];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[66];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[66];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[67];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[67];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[67];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[68];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[68];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[68];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[69];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[69];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[69];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[70];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[70];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[70];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[71];
         rA1 = pA0[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA0[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[71];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[71];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
