#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK72x72x72TN0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=72, NB=72, KB=72, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=3, ku=72, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (((lda) << 6)+((lda) << 3));
   const double *stN = B + (((ldb) << 6)+((ldb) << 3));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 72
   const int incAm = ((((lda) << 2)) - 72), incAn = -(((lda) << 6)+((lda) << 3));
   #define incBk 72
   const int incBm = -72, incBn = (((ldb) << 1)+ldb);
   #define incCm 4
   const int incCn = (((ldc) << 1)+ldc) - 72;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      ATL_pfl1R(pfA+64);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rC0_0 = rA0 * rB0;
         rA2 = *pA2;
         rC1_0 = rA1 * rB0;
         rA3 = *pA3;
         rC2_0 = rA2 * rB0;
         rB1 = *pB1;
         rC3_0 = rA3 * rB0;
         rB2 = *pB2;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC3_1 = rA3 * rB1;
         rC0_2 = rA0 * rB2;
         rC1_2 = rA1 * rB2;
         rC2_2 = rA2 * rB2;
         rC3_2 = rA3 * rB2;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA1[1];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[1];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[1];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[1];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[1];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA1[2];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[2];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[2];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[2];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[2];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA1[3];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[3];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[3];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[3];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[3];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA1[4];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[4];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[4];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[4];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[4];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rA1 = pA1[5];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[5];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[5];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[5];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[5];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA1[6];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[6];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[6];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[6];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[6];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rA1 = pA1[7];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[7];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[7];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[7];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[7];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA1[8];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[8];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[8];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[8];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[8];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rA1 = pA1[9];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[9];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[9];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[9];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[9];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rA1 = pA1[10];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[10];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[10];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[10];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[10];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rA1 = pA1[11];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[11];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[11];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[11];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[11];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rA1 = pA1[12];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[12];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[12];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[12];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[12];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rA1 = pA1[13];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[13];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[13];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[13];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[13];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rA1 = pA1[14];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[14];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[14];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[14];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[14];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rA1 = pA1[15];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[15];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[15];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[15];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[15];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rA1 = pA1[16];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[16];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[16];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[16];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[16];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rA1 = pA1[17];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[17];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[17];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[17];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[17];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rA1 = pA1[18];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[18];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[18];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[18];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[18];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rA1 = pA1[19];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[19];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[19];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[19];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[19];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rA1 = pA1[20];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[20];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[20];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[20];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[20];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rA1 = pA1[21];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[21];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[21];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[21];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[21];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rA1 = pA1[22];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[22];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[22];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[22];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[22];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rA1 = pA1[23];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[23];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[23];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[23];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[23];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rA1 = pA1[24];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[24];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[24];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[24];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[24];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rA1 = pA1[25];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[25];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[25];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[25];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[25];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rA1 = pA1[26];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[26];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[26];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[26];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[26];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rA1 = pA1[27];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[27];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[27];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[27];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[27];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rA1 = pA1[28];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[28];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[28];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[28];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[28];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rA1 = pA1[29];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[29];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[29];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[29];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[29];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rA1 = pA1[30];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[30];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[30];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[30];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[30];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rA1 = pA1[31];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[31];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[31];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[31];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[31];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rA1 = pA1[32];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[32];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[32];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[32];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[32];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rA1 = pA1[33];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[33];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[33];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[33];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[33];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rA1 = pA1[34];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[34];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[34];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[34];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[34];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rA1 = pA1[35];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[35];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[35];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[35];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[35];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rA1 = pA1[36];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[36];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[36];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[36];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[36];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rA1 = pA1[37];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[37];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[37];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[37];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[37];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rA1 = pA1[38];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[38];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[38];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[38];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[38];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rA1 = pA1[39];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[39];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[39];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[39];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[39];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rA1 = pA1[40];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[40];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[40];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[40];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[40];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[41];
         rB0 = pB0[41];
         rA1 = pA1[41];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[41];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[41];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[41];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[41];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rA1 = pA1[42];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[42];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[42];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[42];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[42];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[43];
         rB0 = pB0[43];
         rA1 = pA1[43];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[43];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[43];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[43];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[43];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rA1 = pA1[44];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[44];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[44];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[44];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[44];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[45];
         rB0 = pB0[45];
         rA1 = pA1[45];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[45];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[45];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[45];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[45];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rA1 = pA1[46];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[46];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[46];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[46];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[46];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[47];
         rB0 = pB0[47];
         rA1 = pA1[47];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[47];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[47];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[47];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[47];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[48];
         rB0 = pB0[48];
         rA1 = pA1[48];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[48];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[48];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[48];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[48];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[49];
         rB0 = pB0[49];
         rA1 = pA1[49];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[49];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[49];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[49];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[49];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[50];
         rB0 = pB0[50];
         rA1 = pA1[50];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[50];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[50];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[50];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[50];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[51];
         rB0 = pB0[51];
         rA1 = pA1[51];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[51];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[51];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[51];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[51];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[52];
         rB0 = pB0[52];
         rA1 = pA1[52];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[52];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[52];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[52];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[52];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[53];
         rB0 = pB0[53];
         rA1 = pA1[53];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[53];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[53];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[53];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[53];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[54];
         rB0 = pB0[54];
         rA1 = pA1[54];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[54];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[54];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[54];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[54];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[55];
         rB0 = pB0[55];
         rA1 = pA1[55];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[55];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[55];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[55];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[55];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[56];
         rB0 = pB0[56];
         rA1 = pA1[56];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[56];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[56];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[56];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[56];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[57];
         rB0 = pB0[57];
         rA1 = pA1[57];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[57];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[57];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[57];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[57];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[58];
         rB0 = pB0[58];
         rA1 = pA1[58];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[58];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[58];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[58];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[58];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[59];
         rB0 = pB0[59];
         rA1 = pA1[59];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[59];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[59];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[59];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[59];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[60];
         rB0 = pB0[60];
         rA1 = pA1[60];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[60];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[60];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[60];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[60];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[61];
         rB0 = pB0[61];
         rA1 = pA1[61];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[61];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[61];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[61];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[61];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[62];
         rB0 = pB0[62];
         rA1 = pA1[62];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[62];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[62];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[62];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[62];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[63];
         rB0 = pB0[63];
         rA1 = pA1[63];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[63];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[63];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[63];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[63];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[64];
         rB0 = pB0[64];
         rA1 = pA1[64];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[64];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[64];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[64];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[64];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[65];
         rB0 = pB0[65];
         rA1 = pA1[65];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[65];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[65];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[65];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[65];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[66];
         rB0 = pB0[66];
         rA1 = pA1[66];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[66];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[66];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[66];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[66];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[67];
         rB0 = pB0[67];
         rA1 = pA1[67];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[67];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[67];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[67];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[67];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[68];
         rB0 = pB0[68];
         rA1 = pA1[68];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[68];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[68];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[68];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[68];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[69];
         rB0 = pB0[69];
         rA1 = pA1[69];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[69];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[69];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[69];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[69];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[70];
         rB0 = pB0[70];
         rA1 = pA1[70];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[70];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[70];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[70];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[70];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rA0 = pA0[71];
         rB0 = pB0[71];
         rA1 = pA1[71];
         rC0_0 += rA0 * rB0;
         rA2 = pA2[71];
         rC1_0 += rA1 * rB0;
         rA3 = pA3[71];
         rC2_0 += rA2 * rB0;
         rB1 = pB1[71];
         rC3_0 += rA3 * rB0;
         rB2 = pB2[71];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC3_2 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
